//***********************************************************
//               TEditDesigner ver 1.00 (Jan. 14, 2000)     *
//                                                          *
//                       For Delphi 4/5                     *
//                     Freeware Component                   *
//                            by                            *
//                     Per Linds Larsen                    *
//                   per.lindsoe@larsen.dk                  *
//                                                          *
//  Documentation and updated versions:                     *
//                                                          *
//               http://www.euromind.com/iedelphi           *
//***********************************************************

unit EditDesigner;

interface

uses
  mshtml_tlb, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;


const

  SID_SHTMLEditServices: TGUID = (D1: $3050f7f9; D2: $98b5; D3: $11cf; D4: ($bb, $82, $00, $AA, $00, $bd, $ce, $0b));


type

  TPreHandleEvent = function(inEvtDispId: Integer; const pIEventObj: IHTMLEventObj): HResult of object;
  TPostHandleEvent = function(inEvtDispId: Integer; const pIEventObj: IHTMLEventObj): HResult of object;
  TTranslateAccelerator = function(inEvtDispId: Integer; const pIEventObj: IHTMLEventObj): HResult of object;
  TPostEditorEventNotify = function(inEvtDispId: Integer; const pIEventObj: IHTMLEventObj): HResult of object;


  TEditDesigner = class(TComponent, IUnknown, IHtmlEditDesigner)
  private
    FPreHandleEvent: TPrehandleEvent;
    FPostHandleEvent: TPostHandleEvent;
    FTranslateAccelerator: TTranslateAccelerator;
    FPostEditorEventNotify: TPostEditorEventNotify;
    { Private declarations }
  protected
    { Protected declarations }
    function PreHandleEvent(inEvtDispId: Integer; const pIEventObj: IHTMLEventObj): HResult; stdcall;
    function PostHandleEvent(inEvtDispId: Integer; const pIEventObj: IHTMLEventObj): HResult; stdcall;
    function TranslateAccelerator(inEvtDispId: Integer; const pIEventObj: IHTMLEventObj): HResult; stdcall;
    function PostEditorEventNotify(inEvtDispId: Integer; const pIEventObj: IHTMLEventObj): HResult; stdcall;
  public
    { Public declarations }
  published
    property OnPreHandleEvent: TPreHandleEvent read FPreHandleEvent write FPreHandleEvent;
    property OnPostHandleEvent: TPostHandleEvent read FPostHandleEvent write FPostHandleEvent;
    property OnPostEditorEventNotify: TPostEditorEventNotify read FPostEditorEventNotify write FPostEditorEventNotify;
    property OnTranslateAccelerator: TTranslateAccelerator read FTranslateAccelerator write FTranslateAccelerator;
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TEditDesigner]);
end;

{ TEditDesigner }

function TEditDesigner.PostEditorEventNotify(inEvtDispId: Integer;
  const pIEventObj: IHTMLEventObj): HResult;
begin
  Result := S_FALSE;
  if Assigned(FPostEditorEventNotify) then
    Result := FPostEditorEventNotify(inEvtDispID, pIEventObj);
end;

function TEditDesigner.PostHandleEvent(inEvtDispId: Integer;
  const pIEventObj: IHTMLEventObj): HResult;
begin
  Result := S_FALSE;
  if Assigned(FPostHandleEvent) then
    Result := FPostHandleEvent(inEvtDispID, pIEventObj);

end;

function TEditDesigner.PreHandleEvent(inEvtDispId: Integer;
  const pIEventObj: IHTMLEventObj): HResult;
begin
  Result := S_FALSE;
  if Assigned(FPreHandleEvent) then
    Result := FPreHandleEvent(inEvtDispID, pIEventObj);

end;



function TEditDesigner.TranslateAccelerator(inEvtDispId: Integer;
  const pIEventObj: IHTMLEventObj): HResult;
begin
  Result:=S_FALSE;
  if Assigned(FTranslateAccelerator) then
    Result := FTranslateAccelerator(inEvtDispID, pIEventObj);

end;

end.

