unit FavoritesReg;

interface
uses
  Windows, Classes, Dialogs, DsgnIntf, Favorites, SysUtils;

type
  TAboutPropertyEditor = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;


procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Internet', [TFavorites]);
  RegisterPropertyEditor(TypeInfo(String),
    TFavorites, 'ABOUT', TAboutPropertyEditor);
end;


procedure TAboutPropertyEditor.Edit;
var
  msg: string;
const
  carriage_return = chr(13);
begin
  msg := 'FAVORITES Component v 1.00';
  AppendStr(msg, carriage_return); AppendStr(msg, carriage_return);
  AppendStr(msg, 'FREEWARE 1999');
  AppendStr(msg, carriage_return); AppendStr(msg, carriage_return);
  AppendStr(msg, 'Developed by:');
  AppendStr(msg, carriage_return); AppendStr(msg, carriage_return);
  AppendStr(msg, 'Per Linds Larsen');
  AppendStr(msg, carriage_return); AppendStr(msg, carriage_return);
  AppendStr(msg, carriage_return);
  AppendStr(msg, 'Updates: http://www.euromind.com/IEDelphi');
  AppendStr(msg, carriage_return);
  AppendStr(msg, carriage_return);
  ShowMessage(msg);
end;

function TAboutPropertyEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paDialog, paReadOnly];
end;

function TAboutPropertyEditor.GetValue: string;
begin
  Result := 'Click here...';
end;

end.
 