
//***************************************
//       IEParser ver 1.00              *
//        For Delphi 4 og 5             *
//       Freeware Component             *
//               by                     *
//                                      *
//        Per Linds Larsen             *
//                                      *
//   http://www.euromind.com/iedelphi   *
//***************************************

unit IEParserReg;

interface

uses
  Dialogs, Sysutils, dsgnintf, Classes, IEParser;

type
  TAboutProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

  TIEParserEditor = class(TComponentEditor)
  public
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure Edit; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

procedure Register;

implementation

procedure TAboutProperty.Edit;
begin
  ShowMessage(
    'IEPARSER Component v1.00'#13#13 +
    'FREEWARE 1999'#13#13 +
    'Developed by:'#13#13 +
    'Per Linds Larsen'#13#13#13 +
    'Updates: http://www.euromind.com/IEDelphi' + #13#13);
end;

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paDialog, paReadOnly];
end;

function TAboutProperty.GetValue: string;
begin
  Result := 'Click here...';
end;


procedure Register;
begin
  RegisterComponents('Internet', [TIEParser]);
  RegisterPropertyEditor(TypeInfo(String),
    TIEParser, 'About', TAboutProperty);
  RegisterComponentEditor(TIEParser, TIEParserEditor);

end;

{ TIEParserEditor }

procedure TIEParserEditor.Edit;
begin
  ShowMessage(
    'IEPARSER Component v1.00'#13#13 +
    'FREEWARE 1999'#13#13 +
    'Developed by:'#13#13 +
    'Per Linds Larsen'#13#13#13 +
    'Updates: http://www.euromind.com/IEDelphi' + #13#13);
end;

procedure TIEParserEditor.ExecuteVerb(Index: Integer);
begin
  Edit;
end;

function TIEParserEditor.GetVerb(Index: Integer): string;
begin
  Result := 'About...';
end;

function TIEParserEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

end.

