//***********************************************************
//               TSaxDTDHandler 1.00 (Jan. 14, 2000)        *
//                                                          *
//                       For Delphi  5                      *
//                     Freeware Component                   *
//                            by                            *
//                     Per Linds Larsen                    *
//                   per.lindsoe@larsen.dk                  *
//                                                          *
//  Documentation and updated versions:                     *
//                                                          *
//               http://www.euromind.com/iedelphi           *
//***********************************************************


unit SAXDTDHandler;

interface

uses
 MSXml2_tlb,Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type

  TnotationDeclEvent = procedure(var strName: WideString; var strPublicId: WideString;
                           var strSystemId: WideString) of object;
  TunparsedEntityDeclEvent = procedure(var strName: WideString; var strPublicId: WideString;
                                 var strSystemId: WideString; var strNotationName: WideString) of object;


  TSAXDTDHandler = class(TComponent, IVBSAXDTDHandler)
  private
    { Private declarations }
    FNotationDecl: TnotationDeclEvent;
    FUnparsedEntityDecl: TunparsedEntityDeclEvent;
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure notationDecl(var strName: WideString; var strPublicId: WideString;
                           var strSystemId: WideString); safecall;
    procedure unparsedEntityDecl(var strName: WideString; var strPublicId: WideString;
                                 var strSystemId: WideString; var strNotationName: WideString); safecall;

  published
    { Published declarations }
    property OnNotationDecl: TnotationDeclEvent read FNotationDecl write FNotationDecl;
    property OnUnparsedEntityDecl: TunparsedEntityDeclEvent read FUnparsedEntityDecl write FUnparsedEntityDecl;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TSAXDTDHandler]);
end;

{ TSAXDTDHandler }

procedure TSAXDTDHandler.notationDecl(var strName, strPublicId,
  strSystemId: WideString);
begin
If Assigned(FnotationDecl) then FnotationDecl(strName, strPublicID, strSystemID);
end;

procedure TSAXDTDHandler.unparsedEntityDecl(var strName, strPublicId,
  strSystemId, strNotationName: WideString);
begin
If Assigned(FunparsedEntityDecl) then FunparsedEntityDecl(strName, strPublicID, strSystemID, strNotationName);
end;

end.
