//***********************************************************
//               TSaxDeclHandler 1.00 (Jan. 14, 2000)       *
//                                                          *
//                       For Delphi 5                       *
//                     Freeware Component                   *
//                            by                            *
//                     Per Linds Larsen                    *
//                   per.lindsoe@larsen.dk                  *
//                                                          *
//  Documentation and updated versions:                     *
//                                                          *
//               http://www.euromind.com/iedelphi           *
//***********************************************************


unit SAXDeclHandler;

interface

uses
msxml2_tlb,  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TelementDeclEvent = procedure(var strName: WideString; var strModel: WideString) of object;
  TattributeDeclEvent = procedure(var strElementName: WideString; var strAttributeName: WideString;
                            var strType: WideString; var strValueDefault: WideString;
                            var strValue: WideString) of object;
  TinternalEntityDeclEvent = procedure(var strName: WideString; var strValue: WideString) of object;
  TExternalEntityDeclEvent = procedure(var strName: WideString; var strPublicId: WideString;
                                 var strSystemId: WideString) of object;



  TSAXDeclHandler = class(TComponent, IVBSAXDeclHandler)
  private
    { Private declarations }
// IVBSAXDeclHandler
    FElementDecl: TelementDeclEvent;
    FAttributeDecl: TattributeDeclEvent;
    FInternalEntityDecl: TinternalEntityDeclEvent;
    FExternalEntityDecl: TExternalEntityDeclEvent;
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure elementDecl(var strName: WideString; var strModel: WideString); safecall;
    procedure attributeDecl(var strElementName: WideString; var strAttributeName: WideString;
                            var strType: WideString; var strValueDefault: WideString;
                            var strValue: WideString); safecall;
    procedure internalEntityDecl(var strName: WideString; var strValue: WideString); safecall;
    procedure externalEntityDecl(var strName: WideString; var strPublicId: WideString;
                                 var strSystemId: WideString); safecall;
  published
    { Published declarations }
// IVBSAXDeclHandler
    property OnElementDecl: TelementDeclEvent read FElementDecl write FElementDecl;
    property OnAttributeDecl: TattributeDeclEvent read FAttributeDecl write FAttributeDecl;
    property OnInternalEntityDecl: TinternalEntityDeclEvent read FInternalEntityDecl write FInternalEntityDecl;
    property OnExternalEntityDecl: TExternalEntityDeclEvent read FExternalEntityDecl write FExternalEntityDecl;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TSAXDeclHandler]);
end;

{ TSAXDeclHandler }

procedure TSAXDeclHandler.attributeDecl(var strElementName,
  strAttributeName, strType, strValueDefault, strValue: WideString);
begin
If Assigned(FattributeDecl) then FattributeDecl(strElementName,
  strAttributeName, strType, strValueDefault, strValue);
end;

procedure TSAXDeclHandler.elementDecl(var strName, strModel: WideString);
begin
If Assigned(FelementDecl) then FelementDecl(strName, strModel);
end;

procedure TSAXDeclHandler.externalEntityDecl(var strName, strPublicId,
  strSystemId: WideString);
begin
If Assigned(FexternalEntityDecl) then FexternalEntityDecl(strName, strPublicID, strSystemID);
end;

procedure TSAXDeclHandler.internalEntityDecl(var strName,
  strValue: WideString);
begin
If Assigned(FinternalEntityDecl) then FinternalEntityDecl(strName, StrValue);
end;

end.
