//***********************************************************
//               TSaxErrorHandler 1.00 (Jan. 14, 2000)      *
//                                                          *
//                       For Delphi 5                       *
//                     Freeware Component                   *
//                            by                            *
//                     Per Linds Larsen                    *
//                   per.lindsoe@larsen.dk                  *
//                                                          *
//  Documentation and updated versions:                     *
//                                                          *
//               http://www.euromind.com/iedelphi           *
//***********************************************************


unit SAXErrorHandler;

interface

uses
 activex,  MSXML2_tlb, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type

  TErrorEvent = procedure(const oLocator: IVBSAXLocator; var strErrorMessage: WideString;
                    nErrorCode: Integer) of object;
  TfatalErrorEvent = procedure(const oLocator: IVBSAXLocator; var strErrorMessage: WideString;
                         nErrorCode: Integer) of object;
  TignorableWarningEvent = procedure(const oLocator: IVBSAXLocator; var strErrorMessage: WideString;
                               nErrorCode: Integer) of object;


  TSaxErrorHandler = class(TComponent, IVBSAXErrorHandler)
  private
    { Private declarations }
    FError: TerrorEvent;
    FFatalError: TFatalerrorEvent;
    FIgnorableWarning: TignorableWarningEvent;
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure error(const oLocator: IVBSAXLocator; var strErrorMessage: WideString;
                    nErrorCode: Integer); safecall;
    procedure fatalError(const oLocator: IVBSAXLocator; var strErrorMessage: WideString;
                         nErrorCode: Integer); safecall;
    procedure ignorableWarning(const oLocator: IVBSAXLocator; var strErrorMessage: WideString;
                               nErrorCode: Integer); safecall;
 published
    { Published declarations }
    property OnError: TerrorEvent read FError write FError;
    property OnFatalError: TFatalerrorEvent read FFatalError write FFatalError;
    property OnIgnorableWarning: TignorableWarningEvent read FIgnorableWarning write FIgnorableWarning;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TSaxErrorHandler]);
end;

{ TSaxErrorHandler }

procedure TSaxErrorHandler.error(const oLocator: IVBSAXLocator;
  var strErrorMessage: WideString; nErrorCode: Integer);
begin
If Assigned (FError) then FError(oLocator, strErrorMessage, nErrorCode);
end;

procedure TSaxErrorHandler.fatalError(const oLocator: IVBSAXLocator;
  var strErrorMessage: WideString; nErrorCode: Integer);
begin
If Assigned (FfatalError) then FfatalError(oLocator, strErrorMessage, nErrorCode);
end;

procedure TSaxErrorHandler.ignorableWarning(const oLocator: IVBSAXLocator;
  var strErrorMessage: WideString; nErrorCode: Integer);
begin
If Assigned (FignorableWarning) then FignorableWarning(oLocator, strErrorMessage, nErrorCode);
end;

end.
