//***********************************************************
//               TSaxLexicalHandler 1.00 (Jan. 14, 2000)    *
//                                                          *
//                       For Delphi 5                       *
//                     Freeware Component                   *
//                            by                            *
//                     Per Linds Larsen                    *
//                   per.lindsoe@larsen.dk                  *
//                                                          *
//  Documentation and updated versions:                     *
//                                                          *
//               http://www.euromind.com/iedelphi           *
//***********************************************************

unit SAXLexicalHandler;

interface

uses
 activex,  MSXML2_tlb, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type

  TcommentEvent = procedure(var strChars: WideString) of object;
  TstartCDATAEvent =  procedure of object;
  TendCDATAEvent =  procedure of object;
  TendDTDEvent =  procedure of object;
  TstartDTDEvent = procedure(var strName: WideString; var strPublicId: WideString;
                       var strSystemId: WideString) of object;
  TstartEntityEvent = procedure(var strName: WideString) of object;
  TendEntityEvent = procedure(var strName: WideString) of object;


  TSAXLexicalHandler = class(TComponent, IVBSAXLexicalHandler)
  private
    { Private declarations }
    FStartDTD: TstartDTDEvent;
    FEndDTD: TendDTDEvent;
    FStartEntity: TstartEntityEvent;
    FEndEntity: TendEntityEvent;
    FStartCData: TstartCDATAEvent;
    FEndCData: TendCDATAEvent;
    FComment: TcommentEvent;
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure startDTD(var strName: WideString; var strPublicId: WideString;
                       var strSystemId: WideString); safecall;
    procedure endDTD; safecall;
    procedure startEntity(var strName: WideString); safecall;
    procedure endEntity(var strName: WideString); safecall;
    procedure startCDATA; safecall;
    procedure endCDATA; safecall;
    procedure comment(var strChars: WideString); safecall;
  published
    { Published declarations }
    property OnStartDTD: TstartDTDEvent read FStartDTD write FStartDTD;
    property OnEndDTD: TendDTDEvent read FEndDTD write FEndDTD;
    property OnStartEntity: TstartEntityEvent read FStartEntity write FStartEntity;
    property OnEndEntity: TendEntityEvent read FEndEntity write FEndEntity;
    property OnStartCData: TstartCDATAEvent read FStartCData write FStartCData;
    property OnEndCData: TendCDATAEvent read FEndCData write FEndCData;
    property OnComment: TcommentEvent read FComment write FComment;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TSAXLexicalHandler]);
end;

{ TSAXLexicalHandler }

procedure TSAXLexicalHandler.comment(var strChars: WideString);
begin
If Assigned(Fcomment) then Fcomment(strChars);
end;

procedure TSAXLexicalHandler.endCDATA;
begin
If Assigned(FendCDATA) then FendCDATA();

end;

procedure TSAXLexicalHandler.endDTD;
begin
If Assigned(FendDTD) then FendDTD();
end;

procedure TSAXLexicalHandler.endEntity(var strName: WideString);
begin
If Assigned(FendEntity) then FendEntity(strName);
end;

procedure TSAXLexicalHandler.startCDATA;
begin
If Assigned(FstartCDATA) then FstartCDATA();
end;

procedure TSAXLexicalHandler.startDTD(var strName, strPublicId,
  strSystemId: WideString);
begin
If Assigned(FstartDTD) then FstartDTD(strName,strPublicID, strSystemID);
end;

procedure TSAXLexicalHandler.startEntity(var strName: WideString);
begin
If Assigned(FstartEntity) then FstartEntity(strName);
end;

end.
