

unit IEResTool_U;

interface

uses
  urlmon, activex, shellapi, inifiles, filectrl, dialogs, Windows,
  Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls,
  ExtCtrls, Comobj, Gauges;


type
  TResToolForm = class(TForm)
    BindirBtn: TButton;
    FilesDirBtn: TButton;
    CreateBtn: TButton;
    BinDirEdit: TEdit;
    FilesDirEdit: TEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    CloseBtn: TButton;
    SaveRCFile: TCheckBox;
    SaveHTML: TCheckBox;
    Label3: TLabel;
    TestHtmlDialogBtn: TButton;
    BrowserTestBtn: TButton;
    ResListBox: TListBox;
    Panel1: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    AboutBtn: TButton;
    Gauge1: TGauge;
    OutPutFileName: TComboBox;
    procedure BindirBtnClick(Sender: TObject);
    procedure FilesDirBtnClick(Sender: TObject);
    procedure CreateBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TestHtmlDialogBtnClick(Sender: TObject);
    procedure BrowserTestBtnClick(Sender: TObject);
    procedure AboutBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function ShowHTMLDialog (hwndParent: HWND; pmk : IMoniker;const pvarArgIn: Variant;const pchOptions : POleStr;var pvArgOut: Variant): HRESULT; stdcall;


var
  ResToolForm: TResToolForm;
  OFN: string;
  OutPutDir, BRCC32Dir, FilesDir: string;
  ini: TInifile;

implementation

{$R *.DFM}
{$R *.res}



uses Options_u;


const
mshtml='mshtml.dll';

function ShowHTMLDialog; external mshtml name 'ShowHTMLDialog';



function Compare(List: TStringList; Index1, Index2: Integer): Integer;
begin
  Result := Length(List[index2]) - Length(List[index1]);
end;

function GetFileList(const Path: string; var FileList:
  TStringList): Boolean;
var
  SearchRec: TSearchRec;
  ff: integer;
begin
  GetFileList := False;
  ff := FindFirst(Path + '\*.*', faAnyFile, SearchRec);
  if ff = 0 then
  begin
    GetFileList := True;
    if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
    begin
      if (SearchRec.Attr and $10 <> $10)
        then FileList.Add(SearchRec.Name);
    end;
    repeat
      ff := FindNext(SearchRec);
      if ff = 0 then
      begin
        if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
        begin
          if (SearchRec.Attr and $10 <> $10)
            then FileList.Add(SearchRec.Name);
        end;
      end;
    until ff <> 0;
  end;
  FindClose(Searchrec);
  end;

function FilenameToResName(FName: string): string;
const
  Disallowed = ['/', '+', '-'];
var
  i: Integer;
begin
  if Pos('.htm', Lowercase(Fname)) = 0 then
    Result := Stringreplace(Fname, '.', '', [rfReplaceAll])
  else Result := Copy(Fname, 1, Pos('.', Fname) - 1);
  for i := 1 to Length(Result) do
    if Result[i] in DisAllowed then Result[i] := '_';
end;

procedure CreateProjectFile(Resname, TheName, TheGuid, OutFileName: string);
var
  h, h2: HInst;
  p: Pointer;
  ts: TStringStream;
  F: TStringlist;
  Size: Cardinal;
begin
  f := TStringlist.Create;
  ts := TStringstream.Create('');
  h := findResource(hinstance, Pchar(ResName), '#23');
  size := SizeOfResource(hinstance, h);
  h2 := LoadResource(hInstance, h);
  p := Lockresource(h2);
  Ts.WriteBuffer(P^, Size);
  f.add(Stringreplace(ts.datastring, '[NAME]', TheName, [rfReplaceAll, rfIgnoreCase]));
  f[0] := Stringreplace(f[0], '[GUID]', TheGuid, [rfReplaceAll, rfIgnoreCase]);
  ts.Free;
  f.SavetoFile(OutFileName);
  f.free;
end;


function ExecuteAndWait(Command, Params: string; ShowWindow: Word; Logfile: string): Cardinal;
var
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  saAttr: TSecurityAttributes;
  hOut: THandle;
begin
  saAttr.nLength := sizeof(TSecurityAttributes);
  saAttr.bInheritHandle := True;
  saAttr.lpSecurityDescriptor := nil;
  hOut := CreateFile(PChar(LogFile), GENERIC_READ or GENERIC_WRITE,
    0, @saAttr, CREATE_ALWAYS, FILE_ATTRIBUTE_TEMPORARY, 0);
  ZeroMemory(@ProcessInfo, SizeOf(TProcessInformation));
  ZeroMemory(@StartupInfo, SizeOf(TStartupInfo));
  with StartupInfo do
  begin
    cb := SizeOf(TStartupInfo);
    hStdOutput := hOut;
    hStdError := hOut;
    wShowWindow := ShowWindow;
    dwFlags := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
  end;
  if CreateProcess(nil, PChar('"' + Command + '" "' + Params + '"'),
    @saAttr, @saAttr, True, 0, nil, nil, StartupInfo, ProcessInfo) then
  begin
    WaitForSingleObject(ProcessInfo.hProcess, INFINITE);
    repeat
      GetExitCodeProcess(ProcessInfo.hProcess, Result);
      Application.ProcessMessages;
    until (Result <> STILL_ACTIVE);
    CloseHandle(ProcessInfo.hProcess);
    CloseHandle(ProcessInfo.hThread);
    CloseHandle(hOut);
  end;
end;


procedure TResToolForm.CreateBtnClick(Sender: TObject);
var
  ThisGuid: string;
  JobDone: Boolean;
  temp, s: string;
  InStr, HtmFiles, includes, Files: TStringlist;
  x, y, z: Integer;
label CleanUp;
begin
  Label5.Font.Color := clGreen;
  Label5.Caption := '';
  JobDone := False;
  OFN := Trim(OutPutFileName.Text);
  if FilesDirEdit.Text = '' then begin
    Showmessage('Files Directory missing!');
    exit;
  end;
  if OFN = '' then begin
    Showmessage('Protocol name missing!');
    exit;
  end;
  if not (OFN[1] in ['a'..'z', 'A'..'Z'])
    then begin
    Showmessage('Illegal characters in protocol name!');
    exit;
  end;
  for x := 2 to Length(OFN) do
    if not (OFN[x] in ['a'..'z', 'A'..'Z', '0'..'9'])
      then begin
      Showmessage('Illegal characters in protocol name!');
      exit;
    end;
  OutPutDir := ExtractFilePath(Application.ExeName) + OFN+ '\';
  if not DirectoryExists(OutPutDir) then
    if not CreateDir(OutPutDir) then
    begin
      Showmessage('Could not create Directory: ' + OutputDir);
      exit;
    end;
  ThisGuid := Ini.ReadString('Protocols', OFN, CreateClassID);
  with Ini do
  begin
    WriteString('Protocols', OFN, ThisGUID);
    WriteString('Directories', 'BRCC32', BinDirEdit.text);
    WriteString('Directories', 'FilesDir', FilesDirEdit.text);
    WriteBool('Options', 'SaveRCFile', SaveRCFile.Checked);
    WriteBool('Options', 'SaveTempHTMLFiles', SaveHTML.Checked);
    WriteString('Directories', 'FilesDir', FilesDirEdit.text);
  end;
  FilesDir := FilesDirEdit.Text;
  BRCC32Dir := BinDirEdit.Text;
  if FilesDir[Length(FilesDir)] <> '\' then FilesDir := FilesDir + '\';
  if Brcc32Dir[Length(Brcc32Dir)] <> '\' then Brcc32Dir := Brcc32Dir + '\';
  if not FileExists(brcc32Dir + 'brcc32.exe') then
  begin
    Showmessage(brcc32Dir + 'brcc32.exe not found!');
    exit;
  end;
  if not FileExists(brcc32Dir + 'dcc32.exe') then
  begin
    Showmessage(brcc32Dir + 'dcc32.exe not found!');
    exit;
  end;
  Files := TStringlist.Create;
  HtmFiles := TStringlist.Create;
  GetFileList(FilesDir, Files);
  for y := 0 to Files.Count - 1 do
    if Pos('.htm', lowercase(ExtractFileExt(files[y]))) > 0 then HtmFiles.add(files[y]);
  if HtmFiles.Count = 0 then
  begin
    Showmessage('No HTML files found in directory: ' + FilesDir + '!');
    Files.Free;
    HtmFiles.Free;
    exit;
  end;
  ResListbox.Items.Clear;
  CreateBtn.Enabled := False;
  CloseBtn.Enabled := False;
  Includes := TStringlist.Create;
  InStr := TStringlist.Create;
  Files.CustomSort(Compare);
  Gauge1.visible := true;
  Gauge1.MaxValue := HtmFiles.Count - 1;
  for x := 0 to HtmFiles.Count - 1 do
  begin
    gauge1.Progress := x;
    InStr.loadFromFile(FilesDir + HtmFiles[x]);
    for y := 0 to Files.Count - 1 do
    begin
      Label5.Caption := IntToStr(Includes.Count) + ' files included!';
      S := FileNameToResName(Files[y]);
      for z := 0 to Instr.Count - 1 do begin
        InStr[z] := StringReplace(InStr[z], FilesDir + Files[y], Files[y], [rfReplaceAll, rfIgnoreCase]);
        Temp := StringReplace(InStr[z], Files[y], S, [rfReplaceAll, rfIgnoreCase]);
        if temp <> InStr[z] then
        begin
          Application.ProcessMessages;
          InStr[z] := Temp;
          if (Includes.IndexOf(Files[y]) = -1) then Includes.add(Files[y]);
        end;
      end;
    end;
    InStr.SaveToFile(FilesDir + HtmFiles[x] + '.tmp');
  end;

  for x := 0 to HTMFiles.Count - 1 do
    if Includes.IndexOf(HtmFiles[x]) = -1 then Includes.Add(HtmFiles[x]);
  Label5.Caption := IntToStr(Includes.Count - 1) + ' files included!';
  for x := 0 to Includes.Count - 1 do
  begin
    if Pos('.htm', Lowercase(Includes[x])) > 0 then s := Includes[x] + '.tmp'
    else s := Includes[x];
    Includes[x] := FileNameToResname(Includes[x]) + ' ' + '23' + ' DISCARDABLE "' + FilesDir + s + '"';
  end;
  Gauge1.visible := False;
  Label5.Caption := 'Creating resourcefile: ' + OFN + 'Res.rc';
  Includes.SaveTofile(OutPutDir + OFN + 'Res.rc');
  ExecuteAndWait(brcc32dir + 'brcc32.exe', OutPutDir + OFN + 'Res.rc', SW_HIDE, OutPutDir + 'error.log');
  if not FileExists(OutPutDir + OFN + 'Res.RES') then
  begin
    Showmessage('Error creating ' + Uppercase(OFN) + 'Res.RES!' + #13 + 'See ERROR.LOG');
    goto CleanUp;
  end;
  CreateProjectFile('RES_DLL_TEMPLATE_DPR', OFN, ThisGuid, OutPutDir + OFN + 'Res.dpr');
  CreateProjectFile('UNIT_DLL_TEMPLATE_PAS', OFN, ThisGuid, OutPutDir + OFN + 'DLLProtocol.pas');
  CreateProjectFile('UNIT_EXE_TEMPLATE_PAS', OFN, ThisGuid, OutPutDir + OFN + 'ExeProtocol.pas');
  CreateProjectFile('DLL_TEMPLATE_DPR', OFN, ThisGuid, OutPutDir + OFN + 'Protocol.dpr');
  CreateProjectFile('DLL_TEMPLATE_PAS', OFN, ThisGuid, OutPutDir + '\_' + OFN + 'Protocol.pas');
  Label5.Caption := 'Creating Protocol DLL: ' + OFN + 'Protocol.dll';
  ChDir(OutPutDir);
  ExecuteAndWait(brcc32dir + 'dcc32.exe', OutPutDir + OFN + 'Protocol.dpr', SW_HIDE, OutPutDir + 'error.log');
  ChDir(ExtractFilePath(Application.ExeName));
  if not FileExists(OutPutDir + OFN + 'Protocol.DLL') then
  begin
    Showmessage('Error creating ' + Uppercase(OFN) + 'PROTOCOL.DLL!' + #13 + 'See ERROR.LOG');
    goto CleanUp;
  end;
  Label5.Caption := 'Creating Resource DLL: ' + OFN + 'Res.dll';
  ExecuteAndWait(brcc32dir + 'dcc32.exe', OutPutDir + OFN + 'Res.dpr', SW_HIDE, OutPutDir + 'error.log');
  CreateBtn.enabled := False;
  if not FileExists(OutPutDir + OFN + 'Res.DLL') then
  begin
    Showmessage('Error creating ' + Uppercase(OFN) + 'RES.DLL!' + #13 + 'See ERROR.LOG');
    goto CleanUp;
  end;
  BrowserTestBtn.Enabled := True;
  TestHTMLDialogBtn.Enabled := True;
  for x := 0 to HTMFiles.Count - 1 do
    ResListBox.Items.Add(FileNameToResName(HTMFiles[x]));
  ResListbox.Enabled := True;
  ResListbox.Setfocus;
  ResListbox.ItemIndex := 0;
  JobDone := True;
  Label5.Caption := 'Finished!';
  CleanUp:
  if not JobDone then
  begin
    Gauge1.Visible := False;
    Label5.Font.Color := clRed;
    Label5.Caption := 'Error -  program stopped!';
  end
  else DeleteFile(OutPutDir + 'Error.log');
  if not SaveRCFile.Checked then
    DeleteFile(FilesDir + OFN + '.rc');
  if not SaveHTML.Checked then
    for x := 0 to HTMFiles.Count - 1 do
      DeleteFile(FilesDir + HtmFiles[x] + '.tmp');
  htmfiles.Free;
  includes.free;
  Instr.free;
  Files.Free;
  CreateBtn.enabled := TRUE;
  CloseBtn.Enabled := True;
end;


procedure TResToolForm.BinDirBtnClick(Sender: TObject);
begin
  if SelectDirectory(BRCC32Dir, [], 0) then BinDirEdit.Text := BRCC32Dir;
end;

procedure TResToolForm.FilesDirBtnClick(Sender: TObject);
begin
  if SelectDirectory(FilesDir, [], 0) then FilesDirEdit.Text := FilesDir;
end;

procedure TResToolForm.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TResToolForm.FormShow(Sender: TObject);
begin
  ini := Tinifile.Create(ChangeFileExt(Application.exename, '.ini'));
  ini.readSection('Protocols', OutputfileName.Items);
  BinDirEdit.text := ini.ReadString('Directories', 'BRCC32', '');
  FilesDirEdit.text := ini.ReadString('Directories', 'FilesDir', '');
  SaveRCFile.Checked := ini.ReadBool('Options', 'SaveRCFile', FALSE);
  SaveHTML.Checked := ini.ReadBool('Options', 'SaveTempHTMLfiles', FALSE);
end;

procedure TResToolForm.FormDestroy(Sender: TObject);
begin
  ini.Free;
end;

procedure TResToolForm.TestHtmlDialogBtnClick(Sender: TObject);
begin
  OptionsForm.ShowModal;
end;

procedure TResToolForm.BrowserTestBtnClick(Sender: TObject);
var
  url: string;
begin
  Url := 'res://' + OutPutDir + Lowercase(OFN) + 'Res.dll/' +
    Lowercase(ResListbox.Items[ResListbox.itemindex]);
  ShellExecute(handle, '', Pchar(url), nil, nil, 0);
end;

procedure TResToolForm.AboutBtnClick(Sender: TObject);
var
  Url: string;
  Moniker: IMoniker;
  v1, v2: Variant;
  F: string;
begin
  f := 'dialogHeight: 180px; dialogWidth: 405px; dialogTop: px; dialogLeft: px;' +
    ' center: 1; dialoghide: 0; edge: raised; help: 0; resizable: 0; scroll: 0;' +
    ' status: 0; unadorned: 0;';
  Url := 'res://' + Application.Exename + '/about';
  CreateUrlMoniker(nil, StringToOleStr(Url), Moniker);
  ShowHTMLDialog(Handle, Moniker, v1, StringToOleStr(F), v2);
end;

end.

