
//***************************************
//         App Helper unit              *
//        For Delphi 4 og 5             *
//                                      *
//               by                     *
//                                      *
//        Per Linds Larsen             *
//                                      *
//   http://www.euromind.com/iedelphi   *
//***************************************

unit appHelper;



interface
uses {$IFDEF VER120} d4_app, {$ENDIF} urlmon;


const

  Class_HttpProtocol: TGUID = '{79eac9e2-baf9-11ce-8c82-00aa004ba90b}';
  Class_FtpProtocol: TGUID = '{79eac9e3-baf9-11ce-8c82-00aa004ba90b}';
  Class_GopherProtocol: TGUID = '{79eac9e4-baf9-11ce-8c82-00aa004ba90b}';
  Class_HttpSProtocol: TGUID = '{79eac9e5-baf9-11ce-8c82-00aa004ba90b}';
  Class_MKProtocol: TGUID = '{79eac9e6-baf9-11ce-8c82-00aa004ba90b}';
  Class_FileProtocol: TGUID = '{79eac9e7-baf9-11ce-8c82-00aa004ba90b}';
  Class_StdURLProtocol: TGUID = '{79eac9e1-baf9-11ce-8c82-00aa004ba90b}';



function TraceBindF(grfBindF: Cardinal): string;
function TraceBindStatus(BindStatus: Cardinal): string;
function TraceBindString(BindString: Cardinal): string;
function TraceBSCF(bscf: Cardinal): string;
function TraceGrfPI(grfPI: Cardinal): string;



implementation


function TraceBindString(BindString: Cardinal): string;
begin
  result := '';
  if (BindString = 1) then Result := 'BINDSTRING_HEADERS';
  if (BindString = 2) then Result := 'BINDSTRING_ACCEPT_MIMES';
  if (BindString = 3) then Result := 'BINDSTRING_EXTRA_URL';
  if (BindString = 4) then Result := 'BINDSTRING_LANGUAGE';
  if (BindString = 5) then Result := 'BINDSTRING_USERNAME';
  if (BindString = 6) then Result := 'BINDSTRING_PASSWORD';
  if (BindString = 7) then Result := 'BINDSTRING_UA_PIXELS';
  if (BindString = 8) then Result := 'BINDSTRING_UA_COLOR';
  if (BindString = 9) then Result := 'BINDSTRING_OS';
  if (BindString = 10) then Result := 'BINDSTRING_USERAGENT';
  if (BindString = 11) then Result := 'BINDSTRING_ACCEPT_ENCODINGS';
  if (BindString = 12) then Result := 'BINDSTRING_POST_COOKIE';
  if (BindString = 13) then Result := 'BINDSTRING_POST_DATA_MIME';
  if (BindString = 14) then Result := 'BINDSTRING_URL';
  if (BindString = 15) then Result := 'BINDSTRING_IID';
  if (BindString = 16) then Result := 'BINDSTRING_FLAG_BIND_TO_OBJECT';
  if (BindString = 17) then Result := 'BINDSTRING_PTR_BIND_CONTEXT';
end;

function TraceBindF(grfBindF: Cardinal): string;
begin
  result := '';
  if (grfBindF and BINDF_ASYNCHRONOUS) <> 0 then Result := result + ' BINDF_ASYNCHRONOUS ';
  if (grfBindF and BINDF_NOPROGRESSIVERENDERING) <> 0 then Result := result + ' BINDF_NOPROGRESSIVERENDERING ';
  if (grfBindF and BINDF_OFFLINEOPERATION) <> 0 then Result := result + ' BINDF_OFFLINEOPERATION ';
  if (grfBindF and BINDF_GETNEWESTVERSION) <> 0 then Result := result + ' BINDF_GETNEWESTVERSION ';
  if (grfBindF and BINDF_NOWRITECACHE) <> 0 then Result := result + ' BINDF_NOWRITECACHE ';
  if (grfBindF and BINDF_NEEDFILE) <> 0 then Result := result + ' BINDF_NEEDFILE ';
  if (grfBindF and BINDF_PULLDATA) <> 0 then Result := result + ' BINDF_PULLDATA ';
  if (grfBindF and BINDF_IGNORESECURITYPROBLEM) <> 0 then Result := result + ' BINDF_IGNORESECURITYPROBLEM ';
  if (grfBindF and BINDF_RESYNCHRONIZE) <> 0 then Result := result + ' BINDF_RESYNCHRONIZE ';
  if (grfBindF and BINDF_HYPERLINK) <> 0 then Result := result + ' BINDF_HYPERLINK ';
  if (grfBindF and BINDF_NO_UI) <> 0 then Result := result + ' BINDF_NO_UI ';
  if (grfBindF and BINDF_SILENTOPERATION) <> 0 then Result := result + ' BINDF_SILENTOPERATION ';
  if (grfBindF and BINDF_PRAGMA_NO_CACHE) <> 0 then Result := result + ' BINDF_PRAGMA_NO_CACHE ';
  if (grfBindF and BINDF_FREE_THREADED) <> 0 then Result := result + ' BINDF_FREE_THREADED ';
  if (grfBindF and BINDF_DIRECT_READ) <> 0 then Result := result + ' BINDF_DIRECT_READ ';
  if (grfBindF and BINDF_FORMS_SUBMIT) <> 0 then Result := result + ' BINDF_FORMS_SUBMIT ';
  if (grfBindF and BINDF_GETFROMCACHE_IF_NET_FAIL) <> 0 then Result := result + ' BINDF_GETFROMCACHE_IF_NET_FAIL ';
end;


function TraceBindStatus(BindStatus: Cardinal): string;
begin
  result := '';
  if (BindStatus = 1) then Result := 'BINDSTATUS_FINDINGRESOURCE';
  if (BindStatus = 2) then Result := 'BINDSTATUS_CONNECTING';
  if (BindStatus = 3) then Result := 'BINDSTATUS_REDIRECTING';
  if (BindStatus = 4) then Result := 'BINDSTATUS_BEGINDOWNLOADDATA';
  if (BindStatus = 5) then Result := 'BINDSTATUS_DOWNLOADINGDATA';
  if (BindStatus = 6) then Result := 'BINDSTATUS_ENDDOWNLOADDATA';
  if (BindStatus = 7) then Result := 'BINDSTATUS_BEGINDOWNLOADCOMPONENTS';
  if (BindStatus = 8) then Result := 'BINDSTATUS_INSTALLINGCOMPONENTS';
  if (BindStatus = 9) then Result := 'BINDSTATUS_ENDDOWNLOADCOMPONENTS';
  if (BindStatus = 10) then Result := 'BINDSTATUS_USINGCACHEDCOPY';
  if (BindStatus = 11) then Result := 'BINDSTATUS_SENDINGREQUEST';
  if (BindStatus = 12) then result := 'BINDSTATUS_CLASSIDAVAILABLE';
  if (BindStatus = 13) then Result := 'BINDSTATUS_MIMETYPEAVAILABLE';
  if (BindStatus = 14) then Result := 'BINDSTATUS_CACHEFILENAMEAVAILABLE';
  if (BindStatus = 15) then Result := 'BINDSTATUS_BEGINSYNCOPERATION';
  if (BindStatus = 16) then Result := 'BINDSTATUS_ENDSYNCOPERATION';
  if (BindStatus = 17) then Result := 'BINDSTATUS_BEGINUPLOADDATA';
  if (BindStatus = 18) then Result := 'BINDSTATUS_UPLOADINGDATA';
  if (BindStatus = 19) then Result := 'BINDSTATUS_ENDUPLOADDATA';
  if (BindStatus = 20) then Result := 'BINDSTATUS_PROTOCOLCLASSID';
  if (BindStatus = 21) then Result := 'BINDSTATUS_ENCODING';
  if (BindStatus = 22) then Result := 'BINDSTATUS_VERIFIEDMIMETYPEAVAILABLE';
  if (BindStatus = 23) then Result := 'BINDSTATUS_CLASSINSTALLLOCATION';
  if (BindStatus = 24) then Result := 'BINDSTATUS_DECODING';
  if (BindStatus = 25) then Result := 'BINDSTATUS_LOADINGMIMEHANDLER';
end;


function TraceBSCF(bscf: Cardinal): string;
begin
  result := '';
  if (BSCF and BSCF_FIRSTDATANOTIFICATION) <> 0 then Result := result + ' BSCF_FIRSTDATANOTIFICATION ';
  if (BSCF and BSCF_INTERMEDIATEDATANOTIFICATION) <> 0 then Result := result + ' BSCF_INTERMEDIATEDATANOTIFICATION ';
  if (BSCF and BSCF_LASTDATANOTIFICATION) <> 0 then Result := result + ' BSCF_LASTDATANOTIFICATION ';
  if (BSCF and BSCF_DATAFULLYAVAILABLE) <> 0 then Result := result + ' BSCF_DATAFULLYAVAILABLE ';
  if (BSCF and BSCF_AVAILABLEDATASIZEUNKNOWN) <> 0 then Result := result + ' BSCF_AVAILABLEDATASIZEUNKNOWN ';
end;

function TraceGrfPI(grfPI: Cardinal): string;
begin
  result := '';
  if (grfPI and PI_PARSE_URL) <> 0 then Result := result + ' PI_PARSE_URL ';
  if (grfPI and PI_FILTER_MODE) <> 0 then Result := result + ' PI_FILTER_MODE ';
  if (grfPI and PI_FORCE_ASYNC) <> 0 then Result := result + ' PI_FORCE_ASYNC ';
  if (grfPI and PI_USE_WORKERTHREAD) <> 0 then Result := result + ' PI_USE_WORKERTHREAD ';
  if (grfPI and PI_MIMEVERIFICATION) <> 0 then Result := result + ' PI_MIMEVERIFICATION ';
  if (grfPI and PI_CLSIDLOOKUP) <> 0 then Result := result + ' PI_CLSIDLOOKUP ';
  if (grfPI and PI_DATAPROGRESS) <> 0 then Result := result + ' PI_DATAPROGRESS ';
  if (grfPI and PI_SYNCHRONOUS) <> 0 then Result := result + ' PI_SYNCHRONOUS ';
  if (grfPI and PI_APARTMENTTHREADED) <> 0 then Result := result + ' PI_APARTMENTTHREADED ';
  if (grfPI and PI_CLASSINSTALL) <> 0 then Result := result + ' PI_CLASSINSTALL ';
  if (grfPI and PD_FORCE_SWITCH) <> 0 then Result := result + ' PD_FORCE_SWITCH ';
  if (grfPI and PI_DOCFILECLSIDLOOKUP) <> 0 then Result := result + ' PI_DOCFILECLSIDLOOKUP ';
end;

end.

