unit DHTML;

{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: DHTML.pas, released September 24, 2000.

The Initial Developer of the Original Code is Peter Morris (pete@stuckindoors.com),
Portions created by Peter Morris are Copyright (C) 2000 Peter Morris.
All Rights Reserved.

Purpose of file:
To allow an easy VCL interface to the Microsoft DHTML editor.
You must add this form to the repository

Contributor(s):


Last Modified: September 24, 2000
Current Version: 1.00

You may retrieve the latest version of this file http://www.euromind.com/iedelphi


Known Issues:
It is not brilliant, but it is better than nothing.

PS
Visit my homepages
http://www.stuckindoors.com   for to get your own events page
http://www.stuckindoors.com/dib  for my open-source graphics library+components
-----------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComObj, ActiveX, mshtml_tlb,
  OleCtrls, DHTMLEDLib_TLB, StdCtrls, Buttons, ExtCtrls, IEConst, MSHTML;


const
  IID_IDocHostUIHandler: TGUID = '{bd3f23c0-d43e-11cf-893b-00aa00bdce1a}';
  GUID_TriEditCommandGroup: TGUID = '{2582F1C0-084E-11d1-9A0E-006097C9B344}';
  CMDSETID_Forms3: TGUID = '{DE4BA900-59CA-11CF-9592-444553540000}';

  MSOCMDF_SUPPORTED = OLECMDF_SUPPORTED;
  MSOCMDF_ENABLED = OLECMDF_ENABLED;

  MSOCMDEXECOPT_PROMPTUSER = OLECMDEXECOPT_PROMPTUSER;
  MSOCMDEXECOPT_DONTPROMPTUSER = OLECMDEXECOPT_DONTPROMPTUSER;

type
  THTMLTable = record
    Border,
    CellPadding,
    CellSpacing,
    RowCount,
    ColCount                  : Integer;
    BGColor                   : TColor;
  end;

  THTMLEdit = class(TFrame)
    pnlControl: TPanel;
    btnNew: TSpeedButton;
    btnOpen: TSpeedButton;
    btnSave: TSpeedButton;
    btnCut: TSpeedButton;
    btnCopy: TSpeedButton;
    btnPaste: TSpeedButton;
    btnUndo: TSpeedButton;
    btnRedo: TSpeedButton;
    btnFind: TSpeedButton;
    btnUnderline: TSpeedButton;
    btnItalic: TSpeedButton;
    btnBold: TSpeedButton;
    btnColor: TSpeedButton;
    btnNumList: TSpeedButton;
    btnBullet: TSpeedButton;
    btnDecreaseIndent: TSpeedButton;
    btnIncreaseIndent: TSpeedButton;
    btnAlignLeft: TSpeedButton;
    btnCenter: TSpeedButton;
    btnAlignRight: TSpeedButton;
    cbFontName: TComboBox;
    cbFontSize: TComboBox;
    cbFontStyle: TComboBox;
    DHTML: TDHTMLEdit;
    cdColor: TColorDialog;
    odOpen: TOpenDialog;
    btnHR: TSpeedButton;
    btnImage: TSpeedButton;
    odPicture: TOpenDialog;
    btnUser1: TSpeedButton;
    btnUser2: TSpeedButton;
    btnUser3: TSpeedButton;
    btnUser4: TSpeedButton;
    procedure DHTMLDocumentComplete(Sender: TObject);
    procedure btnUndoClick(Sender: TObject);
    procedure btnRedoClick(Sender: TObject);
    procedure btnCutClick(Sender: TObject);
    procedure btnCopyClick(Sender: TObject);
    procedure btnPasteClick(Sender: TObject);
    procedure btnBoldClick(Sender: TObject);
    procedure btnItalicClick(Sender: TObject);
    procedure btnUnderlineClick(Sender: TObject);
    procedure btnColorClick(Sender: TObject);
    procedure btnNumListClick(Sender: TObject);
    procedure btnBulletClick(Sender: TObject);
    procedure btnDecreaseIndentClick(Sender: TObject);
    procedure btnIncreaseIndentClick(Sender: TObject);
    procedure btnAlignLeftClick(Sender: TObject);
    procedure btnCenterClick(Sender: TObject);
    procedure btnAlignRightClick(Sender: TObject);
    procedure cbFontNameChange(Sender: TObject);
    procedure cbFontSizeChange(Sender: TObject);
    procedure cbFontStyleChange(Sender: TObject);
    procedure btnNewClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure btnHRClick(Sender: TObject);
    procedure DHTMLonclick(Sender: TObject);
    procedure DHTMLonkeyup(Sender: TObject);
    procedure btnImageClick(Sender: TObject);
  private
    { Private declarations }
    DocComplete               : Boolean;
    FStyles                   : TStringList;

    procedure ExecCommand(cmdID, cmdExecOpt, pVar: OleVariant);
    function  GetBold : Boolean;
    function  GetBulletList : Boolean;
    function  GetCommandStatus(ucmdID : Cardinal; bTriEditCmdGroup : boolean) : DWORD;
    function  GetFilename : String;
    function  GetFontName : String;
    function  GetFontSize : Integer;
    function  GetFontStyle : String;
    function  GetItalic : Boolean;
    function  GetNumberedList : Boolean;
    procedure GetSpecialCommandState(cmdID : Cardinal; bTrieditCommandGroup : boolean; var bEnabled, bChecked : boolean);
    procedure GetStyles;
    function  GetTextAlignment : TAlignment;
    function  GetUnderline : Boolean;
    function  HrExecCommand(ucmdID : cardinal; const pVarIn : OleVariant;
                              var pVarOut : OleVariant; bPromptUser : boolean;
                              bTriEditCmdGroup : boolean) : HResult;
    function  QueryStatus(cmdID: OleVariant): OleVariant;
    function  SpecialCommand(Cmd : Cardinal; PromptUser : boolean;
                              editModeOnly : boolean; bTriEditCommandGroup : boolean;
                              InputArgs : OleVariant) : HRESULT;
  protected
    function GetProperty(const Name : String) : OLEVariant;
    procedure SetProperty(const Name : String; Value : OleVariant);

    procedure SetBold(const Value : Boolean); virtual;
    procedure SetBulletList(const Value : Boolean); virtual;
    procedure SetFontName(const Value : String); virtual;
    procedure SetFontSize(const Value : Integer); virtual;
    procedure SetFontStyle(const Value : String); virtual;
    procedure SetItalic(const Value : Boolean); virtual;
    procedure SetTextAlignment(const Value : TAlignment); virtual;
    procedure SetTextColor(const Value : TColor); virtual;
    procedure SetNumberedList(const Value : Boolean); virtual;
    procedure SetUnderline(const Value : Boolean); virtual;
    procedure UpdateDisplay;
  public
    { Public declarations }
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;

    function  CommandTarget : IOleCommandTarget;
    function  DOMInterface : IHtmlDocument2;
    function  CanCopy : Boolean;
    function  CanCut : Boolean;
    function  CanDeleteCells : Boolean;
    function  CanDeleteColumns : Boolean;
    function  CanDeleteRows : Boolean;
    function  CanInsertCell : Boolean;
    function  CanInsertColumn : Boolean;
    function  CanInsertRow : Boolean;
    function  CanMergeCells : Boolean;
    function  CanPaste : Boolean;
    function  CanSplitCell : Boolean;
    procedure ClearSelection;
    procedure Copy;
    procedure Cut;
    procedure DecreaseIndent;
    procedure DeleteCells;
    procedure DeleteColumns;
    procedure DeleteRows;
    procedure Find;
    procedure IncreaseIndent;
    procedure InsertCell;
    procedure InsertColumn;
    procedure InsertHR;
    procedure InsertHTML(const HTML : String);
    procedure InsertImage(const Filename : String);
    procedure InsertLink(const Filename, Caption : String);
    procedure InsertRow;
    procedure InsertTable(const Table : THTMLTable);
    procedure LoadFromFile(const Filename : String);
    procedure MergeCells;
    procedure New;
    procedure Paste;
    procedure ReDo;
    procedure SaveToFile(const Filename : String);
    procedure SelectAll;
    procedure SelectFont;
    procedure SplitCell;
    procedure Undo;

    property Bold             : Boolean
      read GetBold
      write SetBold;
    property BulletList       : Boolean
      read GetBulletList
      write SetBulletList;
    property Italic           : Boolean
      read GetItalic
      write SetItalic;
    property Filename         : String
      read GetFilename;
    property FontName         : String
      read GetFontName
      write SetFontName;
    property FontSize         : Integer
      read GetFontSize
      write SetFontSize;
    property FontStyle        : String
      read GetFontStyle
      write SetFontStyle;
    property TextAlignment    : TAlignment
      read GetTextAlignment
      write SetTextAlignment;
    property TextColor        : TColor
      write SetTextColor;
    property NumberedList     : Boolean
      read GetNumberedList
      write SetNumberedList;
    property Underline        : Boolean
      read GetUnderline
      write SetUnderline;
  end;

function ColorToRGBStr(Color : TColor) : String;
procedure Register;
implementation

{$R *.DFM}
var
   NilVariant : OleVariant;

const
  cHexChars : array[0..15] of char = ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
function ColorToRGBStr(Color : TColor) : String;
  function ByteToHex(B : Byte) : String;
  begin
    Result := cHexChars[(B shr 4) and 15] + cHexChars[B and 15];
  end;

var
  Vals                        : PByteArray;
begin
  Color := ColorToRGB(Color);
  Vals := @Color;
  Result := '';
  Result := ByteToHex(Vals[0]) + ByteToHex(Vals[1]) + ByteToHex(Vals[2]);
end;


procedure Register;
begin
  RegisterComponents('Samples', [THTMLEdit]);
end;

function THTMLEdit.GetProperty(const Name: String): OLEVariant;
var
  V: OleVariant;
begin
  if not DocComplete then exit;
  V := DOMInterface.selection.createRange;
  Result := V.queryCommandValue(Name);
end;

procedure THTMLEdit.SetProperty(const Name: String; Value: OleVariant);
var
  V: OleVariant;
  S: OleVariant;
begin
  if not DocComplete then exit;
  if GetProperty(Name) <> Value then begin
    V := DOMInterface.selection.createRange;
    S := Value;
    V.execCommand(Name , False, S);
    UpdateDisplay;
  end;
end;

function THTMLEdit.CanCopy: Boolean;
begin
  Result := (QueryStatus(DECMD_COPY) and DECMDF_ENABLED) = DECMDF_ENABLED
end;

function THTMLEdit.CanCut: Boolean;
begin
  Result := (QueryStatus(DECMD_CUT) and DECMDF_ENABLED) = DECMDF_ENABLED;
end;

function THTMLEdit.CanPaste: Boolean;
begin
  Result := (QueryStatus(DECMD_PASTE) and DECMDF_ENABLED) = DECMDF_ENABLED;
end;

function THTMLEdit.CommandTarget: IOleCommandTarget;
begin
  Result := DOMInterface as IOleCommandTarget;
end;

procedure THTMLEdit.Copy;
begin
  ExecCommand(DECMD_COPY, OLECMDEXECOPT_DODEFAULT, Null);
end;

constructor THTMLEdit.Create(AOwner: TComponent);
begin
  DocComplete := False;
  inherited;
  if not (csDesigning in ComponentState) then
  begin
  Dhtml.ControlInterface._AddRef;
  DHTML.Align := alClient;
  end;
  FStyles := TStringList.Create;
  cbFontName.Items.Assign(Screen.Fonts);
end;

procedure THTMLEdit.Cut;
begin
  ExecCommand(DECMD_CUT, OLECMDEXECOPT_DODEFAULT, Null);
end;

destructor THTMLEdit.Destroy;
begin
  FStyles.Free;
  inherited;
end;

function THTMLEdit.DOMInterface: IHtmlDocument2;
begin
  Result := DHTML.DOM as IHtmlDocument2;
end;

procedure THTMLEdit.ExecCommand(cmdID, cmdExecOpt, pVar: OleVariant);
begin
  if (DocComplete) and ((QueryStatus(CmdID) and DECMDF_ENABLED) = DECMDF_ENABLED) then
    DHTML.ExecCommand(cmdID, cmdExecOpt, pVar);
end;

procedure THTMLEdit.Paste;
begin
  ExecCommand(DECMD_PASTE, OLECMDEXECOPT_DODEFAULT, Null);
end;

function THTMLEdit.QueryStatus(cmdID: OleVariant): OleVariant;
begin
  Result := DHTML.QueryStatus(cmdID);
end;

procedure THTMLEdit.ReDo;
begin
  SpecialCommand(IDM_REDO,False,True,True,NilVariant);
end;

procedure THTMLEdit.Undo;
begin
  SpecialCommand(IDM_UNDO,False,True,False,NilVariant);
end;

procedure THTMLEdit.DHTMLDocumentComplete(Sender: TObject);
begin
  DocComplete := True;
  if FStyles.Count=0 then begin
    GetStyles;
    cbFontStyle.Items.Assign(FStyles);
  end;
  UpdateDisplay;
end;

procedure THTMLEdit.UpdateDisplay;
var
  TxtAlign                    : TAlignment;
begin
  if not DocComplete then exit;

  btnCopy.Enabled := CanCopy;
  btnCut.Enabled := CanCut;
  btnPaste.Enabled := CanPaste;

  btnBold.Down := Bold;
  btnItalic.Down := Italic;
  btnUnderline.Down := Underline;

  btnNumList.Down := NumberedList;
  btnBullet.Down := BulletList;

  TxtAlign := TextAlignment;
  btnAlignLeft.Down := (txtAlign = taLeftJustify);
  btnCenter.Down := (txtAlign = taCenter);
  btnAlignRight.Down := (txtAlign = taRightJustify);

  cbFontName.ItemIndex := cbFontName.Items.IndexOf(FontName);

  if cbFontSize.Items.IndexOf(IntToStr(FontSize)) =-1 then cbFontSize.Items.Add(IntToStr(FontSize));
  cbFontSize.ItemIndex := cbFontSize.Items.IndexOf(IntToStr(FontSize));

  cbFontStyle.ItemIndex := cbFontStyle.Items.Indexof(FontStyle);
end;

function THTMLEdit.SpecialCommand(Cmd: Cardinal; PromptUser : Boolean;
                                    editModeOnly, bTriEditCommandGroup: boolean;
                                    InputArgs : OleVariant): HRESULT;
begin
  result := HrExecCommand(Cmd, nilVariant, InputArgs, promptUser, bTriEditCommandGroup);
end;

function THTMLEdit.HrExecCommand(ucmdID: cardinal;
  const pVarIn: OleVariant; var pVarOut: OleVariant; bPromptUser,
  bTriEditCmdGroup: boolean): HResult;
var
   dwCmdOpt : DWORD;
begin
   result := S_OK;
   if CommandTarget = nil then Exit;

   if (bPromptUser) then
      dwCmdOpt := MSOCMDEXECOPT_PROMPTUSER
   else
      dwCmdOpt := MSOCMDEXECOPT_DONTPROMPTUSER;

   if (bTriEditCmdGroup) then begin
      result := CommandTarget.Exec(@GUID_TriEditCommandGroup,
							ucmdID,
							dwCmdOpt,
							pVarIn,
							pVarOut);
   end else begin
      result := CommandTarget.Exec(@CMDSETID_Forms3,
							ucmdID,
							dwCmdOpt,
							pVarIn,
							pVarOut);
   end;
end;

procedure THTMLEdit.btnUndoClick(Sender: TObject);
begin
  SpecialCommand(IDM_Undo, false, true, false, NilVariant);
end;

procedure THTMLEdit.btnRedoClick(Sender: TObject);
begin
  SpecialCommand(IDM_ReDo, false, true, false, NilVariant);
end;

procedure THTMLEdit.btnCutClick(Sender: TObject);
begin
  Cut;
end;

procedure THTMLEdit.btnCopyClick(Sender: TObject);
begin
  Copy;
end;

procedure THTMLEdit.btnPasteClick(Sender: TObject);
begin
  Paste;
end;

function THTMLEdit.GetBold: Boolean;
begin
  Result := GetProperty('Bold');
end;

procedure THTMLEdit.SetBold(const Value: Boolean);
begin
  SetProperty('Bold',Value);
end;

procedure THTMLEdit.btnBoldClick(Sender: TObject);
begin
  Bold := btnBold.Down;
end;

procedure THTMLEdit.btnItalicClick(Sender: TObject);
begin
  Italic := btnItalic.Down;
end;

function THTMLEdit.GetItalic: Boolean;
begin
  Result := GetProperty('Italic');
end;

procedure THTMLEdit.SetItalic(const Value: Boolean);
begin
  SetProperty('Italic', Value);
end;

function THTMLEdit.GetUnderline: Boolean;
begin
  Result := GetProperty('Underline');
end;

procedure THTMLEdit.SetUnderline(const Value: Boolean);
begin
  SetProperty('Underline', Value);
end;

procedure THTMLEdit.btnUnderlineClick(Sender: TObject);
begin
  Underline := btnUnderline.Down;
end;

procedure THTMLEdit.btnColorClick(Sender: TObject);
begin
  if cdColor.Execute then TextColor := cdColor.Color;
end;

procedure THTMLEdit.SetTextColor(const Value: TColor);
begin
  SetProperty('ForeColor', Value);
end;


function THTMLEdit.GetCommandStatus(ucmdID: Cardinal;
  bTriEditCmdGroup: boolean): DWORD;
var
   FMsoCmd : TOleCmd;
begin
   result := 0;
   if CommandTarget = nil then Exit;
   
   FMsoCmd.CmdID := ucmdID;
   FMsoCmd.cmdf := 0;
   if (bTriEditCmdGroup) then begin
      CommandTarget.QueryStatus(@GUID_TriEditCommandGroup, 1, @FMsoCmd, nil);
   end else begin
      CommandTarget.QueryStatus(@CMDSETID_Forms3, 1, @FMsoCmd, nil);
   end;
   result := FMsoCmd.cmdf;
end;

function THTMLEdit.GetNumberedList: Boolean;
var
  bEnabled,
  bChecked                    : Boolean;
begin
  GetSpecialCommandState(IDM_ORDERLIST, false, bEnabled, bChecked);
  Result := bEnabled and bChecked;
end;

procedure THTMLEdit.SetNumberedList(const Value: Boolean);
begin
  SpecialCommand(IDM_ORDERLIST, false, true, false, NilVariant);
  UpdateDisplay;
end;

procedure THTMLEdit.GetSpecialCommandState(cmdID: Cardinal;
  bTrieditCommandGroup: boolean; var bEnabled, bChecked: boolean);
var
   dwStatus : DWORD;
begin
   dwStatus := GetCommandStatus(cmdID, bTriEditCommandGroup);
   bEnabled := ((dwStatus and OLECMDF_ENABLED) <> 0);
   bChecked := ((dwStatus and OLECMDF_LATCHED) <> 0);
end;

procedure THTMLEdit.btnNumListClick(Sender: TObject);
begin
  NumberedList := btnNumList.Down;
end;

procedure THTMLEdit.btnBulletClick(Sender: TObject);
begin
  BulletList := btnBullet.Down;
end;

function THTMLEdit.GetBulletList: Boolean;
var
  bEnabled,
  bChecked                    : Boolean;
begin
  GetSpecialCommandState(IDM_UNORDERLIST, false, bEnabled, bChecked);
  Result := bEnabled and bChecked;
end;

procedure THTMLEdit.SetBulletList(const Value: Boolean);
begin
  SpecialCommand(IDM_UNORDERLIST, false, true, false, NilVariant);
  UpdateDisplay;
end;

procedure THTMLEdit.btnDecreaseIndentClick(Sender: TObject);
begin
  DecreaseIndent;
end;

procedure THTMLEdit.DecreaseIndent;
begin
  SpecialCommand(IDM_OUTDENT, false, true, false, NilVariant);
end;

procedure THTMLEdit.IncreaseIndent;
begin
  SpecialCommand(IDM_INDENT, false, true, false, NilVariant);
end;

procedure THTMLEdit.btnIncreaseIndentClick(Sender: TObject);
begin
  IncreaseIndent;
end;

function THTMLEdit.GetTextAlignment: TAlignment;
//var
//  bEnabled,
//  bChecked                    : Boolean;
begin
  if GetProperty('JustifyRight') then
    Result := taRightJustify
  else
  if GetProperty('JustifyCenter') then
    Result := taCenter
  else
    Result := taLeftJustify;
{
  GetSpecialCommandState(IDM_JustifyRight, false, bEnabled, bChecked);
  if bEnabled and bChecked then
    Result := taRightJustify
  else begin
    GetSpecialCommandState(IDM_JustifyCenter, false, bEnabled, bChecked);
    if bEnabled and bChecked then
      Result := taCenter
    else
      Result := taLeftJustify;
  end;}
end;

procedure THTMLEdit.SetTextAlignment(const Value: TAlignment);
begin
  case Value of
    taLeftJustify : SetProperty('JustifyLeft', True);
    taCenter : SetProperty('JustifyCenter', True);
    taRightJustify : SetProperty('JustifyRight', True);
  end;
end;

procedure THTMLEdit.btnAlignLeftClick(Sender: TObject);
begin
  TextAlignment := taLeftJustify;
end;

procedure THTMLEdit.btnCenterClick(Sender: TObject);
begin
  TextAlignment := taCenter;
end;

procedure THTMLEdit.btnAlignRightClick(Sender: TObject);
begin
  TextAlignment := taRightJustify;
end;

function THTMLEdit.GetFontName: String;
begin
  Result := GetProperty('FontName');
end;

procedure THTMLEdit.SetFontName(const Value: String);
begin
  SetProperty('FontName', Value);
end;

procedure THTMLEdit.cbFontNameChange(Sender: TObject);
begin
  FontName := cbFontName.Text;
  DHTML.SetFocus;
end;

function THTMLEdit.GetFontSize: Integer;
begin
  Result := GetProperty('FontSize');
end;

procedure THTMLEdit.SetFontSize(const Value: Integer);
begin
  SetProperty('FontSize', Value);
end;

procedure THTMLEdit.cbFontSizeChange(Sender: TObject);
begin
  FontSize := StrToInt(cbFontSize.text);
  DHTML.SetFocus;
end;

procedure THTMLEdit.GetStyles;
var
   varRange : OleVariant;
   b : TBStr;
   a : PSafeArray;
   l, h, i : longint;
   hr : HRESULT;
begin
  TVariantArg(VarRange).VT := VT_ARRAY; // VarArray or VarOleStr;
  TVariantArg(VarRange).ppArray := nil;
  hr := HrExecCommand(IDM_GETBLOCKFMTS, NilVariant, VarRange, false, false);
  // OleCheck(hr);
  if (hr = 0) then begin
    l := VarArrayLowBound(VarRange, 1);
    h := VarArrayHighBound(VarRange, 1);
    a := TVariantArg(VarRange).pArray;
    for i := l to h do begin
      SafeArrayGetElement(a, i, b);
      FStyles.Add(OleStrToString(b));
    end;
  end;
end;

function THTMLEdit.GetFontStyle: String;
var
  StyleNameStatus             : DWord;
  vo                          : OleVariant;
begin
  Result := '';
  StyleNameStatus := GetCommandStatus(IDM_BLOCKFMT, False);
  if ((StyleNameStatus and OleCmdf_Enabled) <> 0) then begin
    TVariantArg(vo).vt := vt_bstr;
    TVariantArg(vo).bStrVal := nil;
    HrExecCommand(IDM_BLOCKFMT, NilVariant, vo, false, false);

    if (VarType(vo) = VarOleStr) then Result := vo;
  end;
end;

procedure THTMLEdit.SetFontStyle(const Value: String);
var
   vi, vo : OleVariant;
begin
  vi := Value;
  HrExecCommand(IDM_BLOCKFMT, vi, vo, false, false);
  UpdateDisplay;
end;

procedure THTMLEdit.cbFontStyleChange(Sender: TObject);
begin
  FontStyle := cbFontStyle.Text;
  DHTML.SetFocus;
end;

procedure THTMLEdit.btnNewClick(Sender: TObject);
begin
  New;
end;

procedure THTMLEdit.New;
begin
  DocComplete := False;
  DHTML.NewDocument;
end;

procedure THTMLEdit.LoadFromFile(const Filename : String);
var
 pVIn : OleVariant;
 Prompt : OleVariant;
begin
  pVIn := Filename;
  Prompt := False;
  DHTML.LoadDocument(pVIn, Prompt);
  DocComplete := False;
end;

procedure THTMLEdit.btnOpenClick(Sender: TObject);
begin
  if odOpen.Execute then LoadFromFile(odOpen.Filename);
end;

procedure THTMLEdit.SaveToFile(const Filename: String);
var
  vo,
  Prompt                      : OleVariant;
begin
  vo := Filename;
  if (Filename <> '') then
     Prompt := False
  else begin
     vo := '';
     Prompt := True;
  end;
  DHTML.SaveDocument(vo, Prompt);
end;

function THTMLEdit.GetFilename: String;
begin
  Result := DHTML.CurrentDocumentPath;
end;

procedure THTMLEdit.InsertHR;
begin
  SpecialCommand(IDM_HORIZONTALLINE, True, True, False, NilVariant);
end;

procedure THTMLEdit.btnHRClick(Sender: TObject);
begin
  InsertHR;
end;

procedure THTMLEdit.InsertImage(const Filename : String);
var
  vo                          : OleVariant;
begin
  if Filename = '' then begin
    vo := '';
    SpecialCommand(IDM_IMAGE, True, True, False, NilVariant);
  end else begin
    vo := DOMInterface.Selection.CreateRange;
    vo.pasteHTML('<image src="' + Filename + '">');
  end;
end;

procedure THTMLEdit.DHTMLonclick(Sender: TObject);
begin
  UpdateDisplay;
end;

procedure THTMLEdit.DHTMLonkeyup(Sender: TObject);
begin
  UpdateDisplay;
end;

procedure THTMLEdit.btnImageClick(Sender: TObject);
begin
  InsertImage('');
end;

procedure THTMLEdit.InsertHTML(const HTML : String);
var
  vo                          : OleVariant;
begin
  vo := DOMInterface.Selection.CreateRange;
  vo.pasteHTML(HTML);
end;

procedure THTMLEdit.InsertTable(const Table: THTMLTable);
var
  X                           : Integer;
  ColorStr,
  ACol,
  ARow,
  TableStr                    : String;
begin
  with Table do begin
    if (RowCount = 0) or (ColCount = 0) then exit;
    ACol := '';
    ARow := '';

    for X:=1 to ColCount do ACol := ACol + '<td></td>';
    for X:=1 to RowCount do ARow := ARow + '<tr>' + ACol + '</tr>';

    ColorStr := ColorToRGBStr(BGColor);

    TableStr := Format('<table border=%d cellpadding=%d cellspacing=%d bgcolor=#%s>%s</table>',
      [Border, CellPadding, CellSpacing, ColorStr, ARow]);

    InsertHTML(TableStr);
  end;
end;

function THTMLEdit.CanDeleteCells: Boolean;
var
  bEnabled,
  bChecked                    : Boolean;
begin
  GetSpecialCommandState(IDM_TRIED_DELETECELLS, True, bEnabled, bChecked);
  Result := bEnabled or bChecked;
end;

function THTMLEdit.CanDeleteColumns: Boolean;
var
  bEnabled,
  bChecked                    : Boolean;
begin
  GetSpecialCommandState(IDM_TRIED_DELETECOLS, True, bEnabled, bChecked);
  Result := bEnabled or bChecked;
end;

function THTMLEdit.CanDeleteRows: Boolean;
var
  bEnabled,
  bChecked                    : Boolean;
begin
  GetSpecialCommandState(IDM_TRIED_DELETEROWS, True, bEnabled, bChecked);
  Result := bEnabled or bChecked;
end;

function THTMLEdit.CanInsertCell: Boolean;
var
  bEnabled,
  bChecked                    : Boolean;
begin
  GetSpecialCommandState(IDM_TRIED_INSERTCELL, True, bEnabled, bChecked);
  Result := bEnabled or bChecked;
end;

function THTMLEdit.CanInsertColumn: Boolean;
var
  bEnabled,
  bChecked                    : Boolean;
begin
  GetSpecialCommandState(IDM_TRIED_INSERTCOL, True, bEnabled, bChecked);
  Result := bEnabled or bChecked;
end;

function THTMLEdit.CanInsertRow: Boolean;
var
  bEnabled,
  bChecked                    : Boolean;
begin
  GetSpecialCommandState(IDM_TRIED_INSERTROW, True, bEnabled, bChecked);
  Result := bEnabled or bChecked;
end;

function THTMLEdit.CanMergeCells: Boolean;
var
  bEnabled,
  bChecked                    : Boolean;
begin
  GetSpecialCommandState(IDM_TRIED_MERGECELLS, True, bEnabled, bChecked);
  Result := bEnabled or bChecked;
end;

function THTMLEdit.CanSplitCell: Boolean;
var
  bEnabled,
  bChecked                    : Boolean;
begin
  GetSpecialCommandState(IDM_TRIED_SPLITCELL, True, bEnabled, bChecked);
  Result := bEnabled or bChecked;
end;

procedure THTMLEdit.DeleteCells;
begin
  SpecialCommand(IDM_TRIED_DELETECELLS, False, True, True, NilVariant);
end;

procedure THTMLEdit.DeleteColumns;
begin
  SpecialCommand(IDM_TRIED_DELETECOLS, False, True, True, NilVariant);
end;

procedure THTMLEdit.DeleteRows;
begin
  SpecialCommand(IDM_TRIED_DELETEROWS, False, True, True, NilVariant);
end;

procedure THTMLEdit.InsertCell;
begin
  SpecialCommand(IDM_TRIED_INSERTCELL, False, True, True, NilVariant);
end;

procedure THTMLEdit.InsertColumn;
begin
  SpecialCommand(IDM_TRIED_INSERTCOL, False, True, True, NilVariant);
end;

procedure THTMLEdit.InsertRow;
begin
  SpecialCommand(IDM_TRIED_INSERTROW, False, True, True, NilVariant);
end;

procedure THTMLEdit.MergeCells;
begin
  SpecialCommand(IDM_TRIED_MERGECELLS, False, True, True, NilVariant);
end;

procedure THTMLEdit.SplitCell;
begin
  SpecialCommand(IDM_TRIED_SPLITCELL, False, True, True, NilVariant);
end;

procedure THTMLEdit.SelectAll;
begin
  SpecialCommand(IDM_SELECTALL, False, True, False, NilVariant);
end;

procedure THTMLEdit.ClearSelection;
begin
  SpecialCommand(IDM_CLEARSELECTION, False, True, False, NilVariant);
end;

procedure THTMLEdit.Find;
begin
  SpecialCommand(IDM_FIND, True, False, False, NilVariant);
end;

procedure THTMLEdit.InsertLink(const Filename, Caption: String);
var
  vo                          : OleVariant;
begin
  if Filename = '' then begin
    vo := '';
    SpecialCommand(IDM_HYPERLINK, True, True, False, NilVariant);
  end else begin
    vo := DOMInterface.Selection.CreateRange;
    vo.pasteHTML('<a href="' + Filename + '">' + Caption + '</a>');
  end;
end;

procedure THTMLEdit.SelectFont;
begin
  SpecialCommand(IDM_FONT,True,True,False,NilVariant);
end;

initialization
  OleInitialize(nil);
  NilVariant := Null;
finalization
  OleUninitialize;

end.
