unit [NAME]ExeProtocol;

interface

uses
  AxCtrls, ActiveX, Urlmon, Windows, Classes, ComObj;


type
  T[NAME]protocol = class(TComObject, IInternetProtocol)
  protected
    DataStream: IStream;
    TotalSize: Integer;
    Written: Integer;
    function Start(szUrl: LPCWSTR; OIProtSink: IInternetProtocolSink;
      OIBindInfo: IInternetBindInfo; grfPI, dwReserved: DWORD): HResult; stdcall;
    function Continue(const ProtocolData: TProtocolData): HResult; stdcall;
    function Abort(hrReason: HResult; dwOptions: DWORD): HResult; stdcall;
    function Terminate(dwOptions: DWORD): HResult; stdcall;
    function Suspend: HResult; stdcall;
    function Resume: HResult; stdcall;

    function Read(pv: Pointer; cb: ULONG; out cbRead: ULONG): HResult; stdcall;
    function Seek(dlibMove: LARGE_INTEGER; dwOrigin: DWORD; out libNewPosition: ULARGE_INTEGER): HResult; stdcall;
    function LockRequest(dwOptions: DWORD): HResult; stdcall;
    function UnlockRequest: HResult; stdcall;

  end;


procedure Register[NAME]Protocol;
procedure UnRegister[NAME]Protocol;


const
  Class_[NAME]Protocol: TGUID = '[GUID]';


implementation

{$R [NAME]Res.RES}


uses ComServ;

{ T[NAME]Protocol }

var
  hModule: HInst;
  Factory: IClassFactory;
  InternetSession: IInternetSession;


procedure Register[NAME]Protocol;
begin
  CoGetClassObject(Class_[NAME]Protocol, CLSCTX_SERVER, nil, IClassFactory, Factory);
  CoInternetGetSession(0, InternetSession, 0);
  InternetSession.RegisterNameSpace(Factory, Class_[NAME]Protocol, '[NAME]', 0, nil, 0);
end;

procedure UnRegister[NAME]Protocol;
begin
  InternetSession.UnregisterNameSpace(Factory, '[NAME]');
end;



function T[NAME]Protocol.Start(szUrl: LPCWSTR; OIProtSink: IInternetProtocolSink;
  OIBindInfo: IInternetBindInfo; grfPI, dwReserved: DWORD): HResult;
var
  Url: string;
  h2: HInst;
  Data: Pointer;
  Dummy: Int64;
begin
  Totalsize := 0;
  written := 0;
  url := (Copy(szurl, Pos(':', SzUrl) + 1, 255));
  h2 := Findresource(hInstance, Pchar(url), '#23');
  TotalSize := SizeOfResource(hInstance, h2);
  Data := LockResource(LoadResource(hInstance, h2));
  CreateStreamOnHGlobal(0, True, DataStream);
  TOleStream.Create(DataStream).WriteBuffer(Data^, TotalSize);
  DataStream.Seek(0, STREAM_SEEK_SET, Dummy);
  OIProtSink.ReportData(BSCF_FIRSTDATANOTIFICATION or
    BSCF_LASTDATANOTIFICATION or BSCF_DATAFULLYAVAILABLE, TotalSize, TotalSize);
  OIProtSink.ReportResult(S_OK, 0, nil);
  Result := S_OK;
end;

function T[NAME]Protocol.Read(pv: Pointer; cb: ULONG; out cbRead: ULONG): HResult;
begin
  DataStream.Read(pv, cb, @cbRead);
  Inc(written, cbread);
  if (written = totalSize) then
    result := S_FALSE else Result := E_PENDING;
end;


function T[NAME]Protocol.Abort(hrReason: HResult; dwOptions: DWORD): HResult;
begin
  Result := S_OK;
end;

function T[NAME]Protocol.Continue(const ProtocolData: TProtocolData): HResult;
begin
  Result := S_OK;
end;

function T[NAME]Protocol.LockRequest(dwOptions: DWORD): HResult;
begin
  Result := S_OK;
end;


function T[NAME]Protocol.Resume: HResult;
begin
  Result := S_OK;
end;

function T[NAME]Protocol.Seek(dlibMove: LARGE_INTEGER; dwOrigin: DWORD;
  out libNewPosition: ULARGE_INTEGER): HResult;
begin
  Result := S_OK;
end;

function T[NAME]Protocol.Suspend: HResult;
begin
  Result := S_OK;
end;

function T[NAME]Protocol.Terminate(dwOptions: DWORD): HResult;
begin
  result := S_OK;
end;

function T[NAME]Protocol.UnlockRequest: HResult;
begin
  Result := S_OK;
end;


initialization

  TComObjectFactory.Create(ComServer, T[NAME]Protocol, Class_[NAME]Protocol,
    '[NAME]Protocol', '', ciMultiInstance, tmApartment);

end.

